<?php

App::uses('QueueTask', 'Queue.Console/Command/Task');
App::uses('CustomEmail', 'Lib');
App::uses('Email', 'EvEmail.Email');

class QueueEvEmailTask extends QueueTask {

	/**
	 * Run task - send email
	 *
	 * @param array $data
	 * @param int $id
	 * @return bool
	 */
	public function run($data, $id = null) {
		$Email = new CustomEmail();

		// We want to send the email in both HTML and plain text format (apparently this helps stop
		// the email from being flagged as spam).
		$Email->emailFormat('both');

		// Setup the email template.
		$template = !empty($data['template']) ? $data['template'] : 'default';

		// Make sure the base URL gets set.
		Router::fullBaseUrl($data['domain']);
		$Email->domain($data['domain']);

		$Email->template($template);
		$Email->to($data['to']);
		if (!empty($data['cc'])) {
			$Email->cc($data['cc']);
		}
		if (!empty($data['bcc'])) {
			$Email->bcc($data['bcc']);
		}
		if (!empty($data['replyTo'])) {
			$Email->replyTo($data['replyTo']);
		}
		$Email->from($data['from']);
		$Email->subject($data['subject']);
		$Email->viewVars([
			'content' => $data['content'],
			// Generate a plain text version of the email
			'text' => ClassRegistry::init('EvEmail.Email')->textContent($data['content'])
		]);
		// Inline the CSS.
		$Email->helpers(['InlineCss.InlineCss']);
		return $Email->send();
	}

}
